"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const hrtime_now_1 = require("hrtime-now");
const ts_simple_ast_1 = require("ts-simple-ast");
const ts = __importStar(require("typescript"));
const typescript_ast_util_1 = require("typescript-ast-util");
// TODO: issue - break  target class' jsdoc
let classDecl;
function getClassDeclaration(arg) {
    if (arg.containingTarget.kind === ts.SyntaxKind.Identifier && arg.containingTarget.parent && arg.containingTarget.parent.parent && arg.containingTarget.parent.parent.kind === ts.SyntaxKind.HeritageClause) {
        return arg.containingTarget.parent.parent.parent;
    }
    if (arg.containedTarget && arg.containedTarget.kind === ts.SyntaxKind.ExpressionWithTypeArguments && arg.containedTarget.parent && arg.containedTarget.parent.kind === ts.SyntaxKind.HeritageClause) {
        return arg.containedTarget.parent.parent;
    }
}
exports.declareClass = {
    name: 'Declare Class',
    config: { inNewFile: false },
    predicate: (arg) => {
        if (!arg.diagnostics.find(d => d.code === 2304)) {
            arg.log('declareClass predicate false because diagnostic code dont match:  ' + arg.diagnostics.map(d => d.code).join(', '));
            return false;
        }
        classDecl = getClassDeclaration(arg);
        if (classDecl) {
            return true;
        }
        else {
            arg.log('declareClass predicate false because arg.containingTarget.kind dont match ' + typescript_ast_util_1.getKindName(arg.containingTarget.kind));
            return false;
        }
    },
    description: (arg) => {
        return `Declare class or interface "${classDecl.name && classDecl.name.getText() || 'unknown'}"`;
    },
    apply: (arg) => {
        const t0 = hrtime_now_1.now();
        const id = arg.simpleNode;
        const simpleClassDec = id.getFirstAncestorByKind(ts.SyntaxKind.ClassDeclaration);
        let h;
        if (!ts_simple_ast_1.TypeGuards.isHeritageClause(h = id.getFirstAncestorByKind(ts.SyntaxKind.HeritageClause))) {
            return;
        }
        const code = `
${simpleClassDec.isExported() ? 'export ' : ''}${h.getToken() === ts.SyntaxKind.ImplementsKeyword ? 'interface' : 'class'} ${id.getText()} {

}

`;
        arg.simpleNode.getSourceFile().insertText(simpleClassDec.getStart(), code);
        arg.log('apply took ' + hrtime_now_1.timeFrom(t0));
    }
};
//# sourceMappingURL=declareClass.js.map