import { CodeFix } from '../codeFixes';
/**

# Description

declare type for return value but no interface or class declaration is present for that - we create a new interface from return value

# Attacks

"code": "2304",	"message": "Cannot find name 'GResult'.",

# Example,

declare a function like the following - return type is not declared. The suggested fix is to declare it automatically based on the return value of the fn (using typechecking inference)

function fn<T>(): FNResult<T> {
  return { a: 1, b: 's', log: (msg) => boolean, kill: function <T>() { return 1 } }
}
*/
export declare const declareReturnType: CodeFix;
