"use strict";
/*
buggy : TODOS and errors - things that works and things that doesn't work yet
function g(): GResult {	// THIS works
  return { a: 1, b: 's' }
}
const g2 = (): GResult2 => ({ a: 1, b: 's' })// TODO: doesn't work
const g3 = (): GResult3 => { return { a: 1, b: 's' } } // TODO: doesn't work
const h2 = (): HResult2 => ({ // TODO this doesn't work - error!
  a: 1, b: 's', log: (msg) => true, kill: function () { return 1 }
})
const h3 = (): HelloType => {  // TODO this doesn't work
  return {
    a: 1, b: 's', log: (msg) => true, kill: function () { return 1 }
  }
}
function h(): Magallanes { //TODO: generates empty interface
  return {
    a: 1, b: 's', log: (msg: boolean) => { return true }, kill: function () { return 1 }
  }
}
function fn<T>(): FNResult<T> { // THIS works
  return { a: 1, b: 's', log: (msg: string) => { return Math.random() > 0.1 ? true : 'foo' }, kill: function <T>() { return 1 } }
}
*/
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
// TODO: members type params (generics) - both in interface and in members and in params.
// arrow functions with return and without braces _ error!
// TODO: constructors
// TODO: getters / setters ? 
// TODO: test jsdoc
//TODO: check if diagnostic is in the same position  in predicate 
//TODO: appearing in places it shouldnt
const ts = __importStar(require("typescript"));
const typescript_ast_util_1 = require("typescript-ast-util");
const ts_simple_ast_1 = require("ts-simple-ast");
const hrtime_now_1 = require("hrtime-now");
/**

# Description

declare type for return value but no interface or class declaration is present for that - we create a new interface from return value

# Attacks

"code": "2304",	"message": "Cannot find name 'GResult'.",

# Example,

declare a function like the following - return type is not declared. The suggested fix is to declare it automatically based on the return value of the fn (using typechecking inference)

function fn<T>(): FNResult<T> {
  return { a: 1, b: 's', log: (msg) => boolean, kill: function <T>() { return 1 } }
}
*/
exports.declareReturnType = {
    name: 'declareReturnType',
    config: {},
    predicate: (arg) => {
        //TODO: review this predicate
        if (!arg.diagnostics.find(d => d.code === 2304)) {
            return false;
        }
        if (arg.containingTargetLight.kind === ts.SyntaxKind.Identifier) {
            return true;
        }
        else {
            arg.log('declareReturnType predicate false because child.kind dont match ' + typescript_ast_util_1.getKindName(arg.containingTarget.kind));
            return false;
        }
    },
    description: (arg) => `Declare Type "${arg.containingTarget.getText()}" interring from return value`,
    apply: (arg) => {
        const id = arg.simpleNode;
        const decl = arg.simpleNode.getFirstAncestorByKind(ts.SyntaxKind.FunctionDeclaration);
        const intStruct = hrtime_now_1.fromNow(() => inferReturnType(decl, arg), t => arg.log('declareReturnType apply inferReturnType took ' + t));
        arg.simpleNode.getSourceFile().addInterface(intStruct);
    }
};
const inferReturnType = (decl, arg) => {
    const project = arg.simpleProject;
    const tmpSourceFile = hrtime_now_1.fromNow(() => project.createSourceFile('tmp2.ts', decl.getText() + '; const tmp = ' + decl.getName() + '()'), (t) => arg.log('declareReturnType apply inferReturnType createSourceFile took ' + t));
    const tmpDecl = tmpSourceFile.getDescendantsOfKind(ts.SyntaxKind.FunctionDeclaration)[0];
    const typeargs = tmpDecl.getReturnType().getTypeArguments();
    hrtime_now_1.fromNow(() => tmpDecl.removeReturnType(), t => arg.log('declareReturnType apply inferReturnType tmpDecl.removeReturnType() took ' + t));
    const tmp = tmpSourceFile.getFirstDescendantByKind(ts.SyntaxKind.VariableDeclaration);
    const type = hrtime_now_1.fromNow(() => project.getTypeChecker().getTypeAtLocation(tmp), t => arg.log('declareReturnType apply inferReturnType getTypeChecker().getTypeAtLocation took ' + t));
    const intStructureT0 = hrtime_now_1.now();
    const intStructure = {
        name: decl.getReturnTypeNode().getText(),
        properties: type.getProperties()
            .filter(p => {
            const v = p.getValueDeclaration();
            return ts_simple_ast_1.TypeGuards.isPropertyAssignment(v) && !v.getInitializer().getKindName().includes('Function');
        })
            .map(p => ({
            name: p.getName(),
            type: project.getTypeChecker().getTypeAtLocation(p.getValueDeclaration()).getText(),
            val: p.getValueDeclaration()
        })),
        methods: type.getProperties()
            .filter(p => {
            const v = p.getValueDeclaration();
            return ts_simple_ast_1.TypeGuards.isPropertyAssignment(v) && v.getInitializer().getKindName().includes('Function');
        })
            .map(p => {
            const v = p.getValueDeclaration();
            if (!ts_simple_ast_1.TypeGuards.isPropertyAssignment(v)) {
                return null;
            }
            const init = v.getInitializer();
            if (!ts_simple_ast_1.TypeGuards.isArrowFunction(init) && !ts_simple_ast_1.TypeGuards.isFunctionExpression(init)) {
                return null;
            }
            return {
                name: p.getName(),
                returnType: init.getReturnType() ? init.getReturnType().getText() : 'any',
                parameters: init.getParameters().map(pa => ({
                    name: pa.getName(),
                    type: pa.getType().getText()
                }))
            };
        })
            .filter(p => !!p),
        typeParameters: typeargs.map(ta => ({ name: ta.getSymbol().getName() })),
    };
    arg.log('declareReturnType apply inferReturnType create InterfaceStructure took ' + hrtime_now_1.timeFrom(intStructureT0));
    hrtime_now_1.fromNow(() => tmpSourceFile.delete(), (t) => arg.log(`declareReturnType apply inferReturnType tmpSourceFile.delete() took ${t}`));
    return intStructure;
};
//# sourceMappingURL=declareReturnType.js.map