"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const ts = __importStar(require("typescript"));
const typescript_ast_util_1 = require("typescript-ast-util");
/**

# description

assign an undeclared variable to a vaalue

example:

a=1


# attacks :
"code": "2304", Cannot find name 'b'.",

TODO: test with jsdoc or a trailing comment
ISSUE : not suggesting in this case:  "a=new A(1)" - if in a new statement dont suggest
*/
exports.codeFixCreateVariable = {
    name: 'Declare variable',
    config: { variableType: 'const' },
    predicate: (options) => {
        if (!options.diagnostics.find(d => d.code === 2304)) {
            return false;
        }
        if (options.containingTarget.kind === ts.SyntaxKind.BinaryExpression ||
            options.containingTarget.parent && options.containingTarget.parent.kind === ts.SyntaxKind.BinaryExpression ||
            options.containingTarget.parent.parent && options.containingTarget.parent.parent.kind === ts.SyntaxKind.BinaryExpression) {
            return true;
        }
        else {
            options.log('codeFixCreateVariable predicate false because child.kind dont match ' + typescript_ast_util_1.getKindName(options.containingTarget.kind));
            return false;
        }
    },
    description: (options) => `Declare variable "${options.containingTarget.getText()}"`,
    apply: (options) => {
        options.simpleNode.getSourceFile().insertText(options.simpleNode.getStart(), 'const ');
    }
};
//# sourceMappingURL=declareVariable.js.map