"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
/**

#description

function declarations without names when they are not called is an error - suggest putting a name

# attacks

"code": "1003",	"message": "Identifier expected."

Example:

function(){}

*/
const ts_simple_ast_1 = require("ts-simple-ast");
const ts = __importStar(require("typescript"));
const typescript_ast_util_1 = require("typescript-ast-util");
exports.nameFunction = {
    name: 'nameFunction',
    config: { newName: 'unnamedFunction' },
    predicate: (arg) => {
        if (!arg.diagnostics.find(d => d.code === 1003)) {
            return false;
        }
        if (arg.containingTarget && ts.isFunctionDeclaration(arg.containingTarget) && (!arg.containingTarget.name || !arg.containingTarget.name.getText()) || (arg.containedTarget && arg.containedTarget.parent && ts.isFunctionDeclaration(arg.containedTarget.parent) && (!arg.containedTarget.parent.name || !arg.containedTarget.parent.name.getText()))) {
            return true;
        }
        else {
            arg.log(`nameFunction predicate false because ${arg.containingTarget && typescript_ast_util_1.getKindName(arg.containingTarget)}  ${arg.containedTarget && typescript_ast_util_1.getKindName(arg.containedTarget)} ${arg.containedTarget.parent && typescript_ast_util_1.getKindName(arg.containedTarget.parent)} ${arg.containedTarget && arg.containedTarget.parent && arg.containedTarget.parent.parent && arg.containedTarget.parent.parent && typescript_ast_util_1.getKindName(arg.containedTarget.parent.parent)} is not FunctionDeclaration or has name`);
            return false;
        }
    },
    description: (arg) => `Name Function`,
    apply: (arg) => {
        const f = ts_simple_ast_1.TypeGuards.isFunctionDeclaration(arg.simpleNode) ? arg.simpleNode : arg.simpleNode.getFirstAncestorByKind(ts.SyntaxKind.FunctionDeclaration);
        if (!f || f.getName()) {
            arg.log(`nameFunction apply cannot exec because ${f.getKindName()} is not FunctionDeclaration or has name`);
            return;
        }
        else {
            const start = f.getNameNode().getStart();
            f.getSourceFile().insertText(f.getNameNode().getStart(), ' unnamedFunction');
        }
    }
};
//# sourceMappingURL=nameFunction.js.map